#include <sta/bus/spi/spi.hpp>

#include <cstdio>

namespace sta
{
    SPI::SPI(const SPISettings & settings, Mutex * mutex /* = nullptr */)
        : Interface{mutex}, settings_{settings}
    {
        
    }

    bool SPI::writeMemory(uint8_t regAddr, const uint8_t * buffer, size_t size, uint32_t timeout /* = STA_MAX_TIMEOUT */)
    {
        if (!transfer(regAddr, timeout))
            return false;

        if (!transfer(buffer, size, timeout))
            return false;

        return true;
    }

    bool SPI::readMemory(uint8_t regAddr, uint8_t * buffer, size_t size, uint32_t timeout /* = STA_MAX_TIMEOUT */)
    {
        if (!transfer(regAddr, timeout))
            return false;

        if (!receive(buffer, size, timeout))
            return false;

        return true;
    }

    const SPISettings & SPI::settings()
    {
        return settings_;
    }
} // namespace sta
